import { HttpService } from "@nestjs/axios";
import { Observable } from "rxjs";

// import { FisUASRequestMessage } from "../../FisAppQueryModule/message/fis.request.message";
import { APReceiptDocument, APReceiptDocumentUnion } from "../entities/APReceiptDocument";
import { FisCreateMessageUtility } from "../message/fisappmessagejsutility/interface/export";
import { DocumentDataService } from "./Document.dataservice";


export class APReceiptDocumentDataService extends DocumentDataService {
    
    // // static ResponseService: FisUASRequestMessage;
    static ResponseService:FisCreateMessageUtility = new FisCreateMessageUtility("FisAppID/Name")
    
    static data:Record<string,any> = {"serviceId": "Document Data", "parameter": "doccategory=RC,subsystemcode=AP" };

    constructor(http: HttpService, ucpId: string, data= APReceiptDocumentDataService.data){
        super(http,ucpId, data);
    }

    getData(className,filter,returnFormatType): Observable<typeof APReceiptDocumentUnion> {
   
            let message : Array<typeof APReceiptDocumentUnion> = [];
            let data: APReceiptDocument[] = [];
 
            return this.getDataWithType(filter,className,message,returnFormatType,data)

    }

    
}