import { HttpService } from "@nestjs/axios";
import { Observable } from "rxjs";
import { LeaveBalance, LeaveBalanceUnion } from "../entities/LeaveBalance";
import { FisCreateMessageUtility } from "../message/fisappmessagejsutility/interface/export";
import { CommonDataService } from "./Common.dataservice";


export class LeaveBalanceDataService extends CommonDataService {
    
    static ResponseService:FisCreateMessageUtility = new FisCreateMessageUtility("FisAppID/Name")

    static data:Record<string,any> = {"serviceId": "Leave Balance Data", "parameter": "" };

    constructor(http: HttpService, ucpId: string, data= LeaveBalanceDataService.data){
        super(http,ucpId, data);
    }


    getData(className,filter,returnFormatType): Observable<typeof LeaveBalanceUnion> {
       
            let message : Array<typeof LeaveBalanceUnion> = [];
            let data: LeaveBalance[] = [];
 
            return this.getDataWithType(filter,className,message,returnFormatType,data)

    }
    
    
}