import { ArgsType, createUnionType, Field, ObjectType } from '@nestjs/graphql';
import { Document, DocumentMessage } from './Document';
import { Document as DocumentType } from '../message/fisappmessagejsutility/interface/export';
import { StatusResponse } from './StatusResponse';
import { SummaryResponse } from './DescendentDataServiceArgument.entity';

export const thisClassName = "ARInvoiceDocumentDataService";

@ObjectType()
@ArgsType() 
export class ARInvoiceDocumentMessage extends DocumentMessage { 


  @Field(type => [ARInvoiceDocument]) 
  data?: ARInvoiceDocument[];

}
@ObjectType()
@ArgsType() 
export class ARInvoiceDocument extends Document implements DocumentType {
}

@ObjectType()
@ArgsType() 
export class ARInvoiceDocumentUnion {

    @Field(type=> SummaryResponse, { nullable: true})
    SummaryResponse?:SummaryResponse;

    @Field(type=> StatusResponse, { nullable: true})
    StatusResponse?:StatusResponse;

    @Field(type=> ARInvoiceDocumentMessage, { nullable: true})
    ARInvoiceDocumentMessage?:ARInvoiceDocumentMessage
}