import { ArgsType, Field, ObjectType } from '@nestjs/graphql';

import { IsNotEmpty,Validate  } from 'class-validator';
import { CustomClassname } from './CustomClassname.validate';
import { CommonDataServiceArgument, CommonDataServiceMessage } from './CommonDataService.entity';

export const thisClassName = "DataService"; 

@ObjectType()
@ArgsType() 
export class DataServiceArgument extends CommonDataServiceArgument{ 

  @Field()
  @IsNotEmpty()
  @Validate(CustomClassname)
  public className?: string = thisClassName;

}

@ObjectType()
@ArgsType() 
export class DataServiceMessage extends CommonDataServiceMessage {
 
  @Field(type => String)
  className: string = thisClassName;  

}
 