import { ArgsType,    Field,    Int,  ObjectType } from '@nestjs/graphql';
import {   SummaryResponse } from './DescendentDataServiceArgument.entity';
import { LeaveBalance as LeaveBalanceType } from '../message/fisappmessagejsutility/interface/export';
import { CustomFilter } from './CustomFilter.validate';
import { CustomReturnFormatType } from './CustomReturnFormatType.validate';
import { Validate } from 'class-validator'
import { StatusResponse } from './StatusResponse';


export const thisClassName = "LeaveBalanceDataService";

@ObjectType()
@ArgsType() 
export class LeaveBalanceArgument {

    className: string = thisClassName;

    
    @Field({ nullable: true })
    @Validate(CustomFilter)
    filter?: string; 

    @Field({ nullable: true })
    @Validate(CustomReturnFormatType)
    returnFormatType?: string;
 
}


@ObjectType()
@ArgsType() 
export class LeaveBalanceMessage {

    @Field(type => [LeaveBalance]) 
    data?: LeaveBalance[]; 
}


@ObjectType()
@ArgsType() 
export class LeaveBalance implements LeaveBalanceType{
    @Field(type=> Int,{ nullable: true})
    emp_role_id: number;

    @Field(type=> Int,{ nullable: true})
    emp_leave_mas_id: number;

    @Field({ nullable: true})
    ps_emp_leave_master_emp_lv_pro_rate: string;

    @Field({ nullable: true})
    ps_emp_leave_master_emp_lv_mas_create_ty: string;

    @Field({ nullable: true})
    ps_leave_desc: string;

    @Field(type=> Int,{ nullable: true})
    emp_lv_mas_year: number;

    @Field({ nullable: true})
    emp_lv_mas_carr_forw: string;

    @Field(type=> Int,{ nullable: true})
    emp_lv_mas_max_time: number;

    @Field({ nullable: true})
    emp_lv_pro_rate: string;

    @Field(type=> Int,{ nullable: true})
    emp_lv_taken: number;

    @Field({ nullable: true})
    emp_lv_mas_earned: string;

    @Field({ nullable: true})
    emp_lv_mas_entitled: string;

    @Field({ nullable: true})
    emp_lv_mas_brou_forw: string;

    @Field({ nullable: true})
    ps_emp_leave_master_emp_lv_mas_open: string;

    @Field({ nullable: true})
    ps_emp_leave_master_emp_lv_mas_allow_car: string;

    @Field(type=> Int,{ nullable: true})
    emp_lv_balance: number; 
   
}


@ObjectType()
@ArgsType() 
export class LeaveBalanceUnion {

    @Field(type=> SummaryResponse, { nullable: true})
    SummaryResponse?:SummaryResponse;

    @Field(type=> StatusResponse, { nullable: true})
    StatusResponse?:StatusResponse;

    @Field(type=> LeaveBalanceMessage, { nullable: true})
    LeaveBalanceMessage?:LeaveBalanceMessage
}