import { ArgsType,  createUnionType,  Field,  Int,  ObjectType } from '@nestjs/graphql';
import { SummaryResponse } from './DescendentDataServiceArgument.entity';
import { RoleTypeProfile as RoleTypeProfileType } from '../message/fisappmessagejsutility/interface/export'
import { StatusResponse } from './StatusResponse';
import { Validate } from 'class-validator';
import { CustomFilter } from './CustomFilter.validate';
import { CustomReturnFormatType } from './CustomReturnFormatType.validate';

export const thisClassName = "RoleTypeProfileDataService";


@ObjectType()
@ArgsType() 
export class RoleTypeProfileArgument {

    className: string = thisClassName;

    @Field({ nullable: true })
    @Validate(CustomFilter)
    filter?: string; 

    @Field({ nullable: true })
    @Validate(CustomReturnFormatType)
    returnFormatType?: string;
 
}


@ObjectType()
@ArgsType() 
export class RoleTypeProfileMessage {

    
    @Field(type => [RoleTypeProfile]) 
    data?: RoleTypeProfile[]; 
 
}


@ObjectType()
@ArgsType() 
export class RoleTypeProfile implements RoleTypeProfileType {

    @Field( type=> Int,{ nullable: true})
    role_id: number;

    @Field({ nullable: true})
    role_cat: string;

    @Field({ nullable: true})
    role_type: string;

    @Field({ nullable: true})
    role_desc: string;
   
}


@ObjectType()
@ArgsType() 
export class RoleTypeProfileUnion {

    @Field(type=> SummaryResponse, { nullable: true})
    SummaryResponse?:SummaryResponse;

    @Field(type=> StatusResponse, { nullable: true})
    StatusResponse?:StatusResponse;

    @Field(type=> RoleTypeProfileMessage, { nullable: true})
    RoleTypeProfileMessage?:RoleTypeProfileMessage
}
