import { ArgsType,  Field,  Int,  ObjectType } from '@nestjs/graphql';
import { DescendentDataServiceArgument, SummaryResponse } from './DescendentDataServiceArgument.entity';
import { ServiceProgram as ServiceProgramType } from '../message/fisappmessagejsutility/interface/export'
import { CustomFilter } from './CustomFilter.validate';
import { CustomReturnFormatType } from './CustomReturnFormatType.validate';
import { Validate } from 'class-validator'
import { StatusResponse } from './StatusResponse';

export const thisClassName = "ServiceProgramProfileDataService";

@ObjectType()
@ArgsType() 
export class ServiceProgramProfileArgument {

    className: string = thisClassName;

    
    @Field({ nullable: true })
    @Validate(CustomFilter)
    filter?: string; 

    @Field({ nullable: true })
    @Validate(CustomReturnFormatType)
    returnFormatType?: string;
 
}


@ObjectType()
@ArgsType() 
export class ServiceProgramProfileMessage {

    
    @Field(type => [ServiceProgramProfile]) 
    data?: ServiceProgramProfile[]; 

}


@ObjectType()
@ArgsType() 
export class ServiceProgramProfile implements ServiceProgramType{

    @Field(type=> Int, { nullable: true})
    fisappserviceid: number;

    @Field({ nullable: true})
    servicetypedesc: string;

    @Field({ nullable: true})
    prg_startup_prg: string;

    @Field({ nullable: true})
    servicetypecode: string;

    @Field({ nullable: true})
    servicename: string;

    @Field({ nullable: true})
    serviceid: string;

    @Field({ nullable: true})
    serviceprogram: string;
   
}

@ObjectType()
@ArgsType() 
export class ServiceProgramProfileUnion {

    @Field(type=> SummaryResponse, { nullable: true})
    SummaryResponse?:SummaryResponse;

    @Field(type=> StatusResponse, { nullable: true})
    StatusResponse?:StatusResponse;

    @Field(type=> ServiceProgramProfileMessage, { nullable: true})
    ServiceProgramProfileMessage?:ServiceProgramProfileMessage
}

