import { Parent, ResolveField, Resolver } from '@nestjs/graphql';
import { Observable } from 'rxjs';
import { Block } from '../../PlantationSiteOperationModule/block/block.entity';
import { BlockService } from '../../PlantationSiteOperationModule/block/block.service';
import { Phase } from './phase.entity';

@Resolver(() => Phase)
export class PhaseResolver {
  constructor(private readonly blockService: BlockService) {}

  @ResolveField('blocks', (returns) => [Block])
  getBlocks(@Parent() phase: Phase): Observable<Block[]> {
    const { sec_id, db } = phase;
    return this.blockService.findAllBlock(db, sec_id);
  }
}
